//+------------------------------------------------------------------+
//|                                                  Dave Valentine  |
//|                                               http://www.xna.hu  |
//+------------------------------------------------------------------+
#property copyright "Dave Valentine"
#property link      "http://www.xna.hu"
#define NAME		"Haru"


#property show_inputs
#include <WinUser32.mqh>

#import "user32.dll"
int GetParent( int hWnd );
int GetDlgItem( int hDlg, int nIDDlgItem );
int GetLastActivePopup( int hWnd );
#import

#define VK_HOME 0x24
#define VK_DOWN 0x28
#define VK_ENTER 0x0D


//+------------------------------------------------------------------+
//| Variables                                                        |
//+------------------------------------------------------------------+

extern string  TradeComment        = "So japanese today";

extern string  NumberPortionSet    = "Account Portion";
extern int     Portion             = 1;    // Portion of account you want to trade on this pair

extern bool    UseEquityProtection = true; // Close all orders when negative Float is excessive.
extern double  FloatPercent        = 100;   // Percent of portion for max Float level.

extern bool    TrailingStopManager = true;   
extern bool    TrailOnlyProfit     = false;   
extern int     TrailingStop        = 100;   

extern double  LAF                 = 0.5;  // Adjusts MM base lot for large accounts (.01 - 5.0)
extern int     Accounttype         = 1;   // Used in Money Management feature only. 1=standard, 10=micro for penny/pip)
extern double  Multiplier          = 1.2;  // Multiplier on each level Hedge Multiplier.  Adjust by +/-.01 intervals

extern int     LowBar              = 24; // Number of bar used for finding the lowest price
extern int     HighBar             = 24; // Number of bar used for finding the highest price

extern string  TimeGridSet         = "Default grid set time in seconds";
extern int     TimeGrid            = 6400; // Time Grid in seconds , to avoid opening of lots of levels in fast market
extern int     TimeGridClose       = 600; // Time Grid in seconds , to avoid opening of lots of levels in fast market
                                   //600

extern int     TenkanSen           = 5;
extern int     KijunSen            = 13;
extern int     SenkoSpan           = 50; //52

extern double  IchiFastDivider     = 1; // Create fast and slow Ichi
extern double  IchiSlowMultiplier  = 2;
extern int     IchiTF_Fast         = PERIOD_M15; // Time Frame
extern int     IchiTF_Slow         = PERIOD_M15;

extern int     slippage            = 999; // Tolerance of order slips/requotes for closing

extern bool    MaximizeProfit      = true; // Turns on TP move and Profit Trailing Stop Feature
extern double  ProfitSet           = 90;   // Locks in Profit at this percent of Total Profit Potential
extern int     MoveTP              = 30;   // Moves TP this amount in pips
extern int     TotalMoves          = 2;    // Number of times you want TP to move before stopping movement

extern bool    HedgingAllowed      = false;
extern int     bufferPIP           = 5;    // Number of pips to move TPs if Profit Potential is negative

extern int     VROC                = 23; // Original is 24

//+------------------------------------------------------------------+
//| Internal Parameters Set                                          |
//+------------------------------------------------------------------+
int MagicNumber   = 0;
int BrokerDecimal = 1;
string POSL_On    = "Yes";
int count;
string STOP = "";

   
int init()
{


   if (Symbol() == "AUDCADm" || Symbol() == "AUDCAD") MagicNumber = 101101;
   if (Symbol() == "AUDJPYm" || Symbol() == "AUDJPY") MagicNumber = 101102;
   if (Symbol() == "AUDNZDm" || Symbol() == "AUDNZD") MagicNumber = 101103;
   if (Symbol() == "AUDUSDm" || Symbol() == "AUDUSD") MagicNumber = 101104;
   if (Symbol() == "CHFJPYm" || Symbol() == "CHFJPY") MagicNumber = 101105;
   if (Symbol() == "EURAUDm" || Symbol() == "EURAUD") MagicNumber = 101106;
   if (Symbol() == "EURCADm" || Symbol() == "EURCAD") MagicNumber = 101107;
   if (Symbol() == "EURCHFm" || Symbol() == "EURCHF") MagicNumber = 101108;
   if (Symbol() == "EURGBPm" || Symbol() == "EURGBP") MagicNumber = 101109;
   if (Symbol() == "EURJPYm" || Symbol() == "EURJPY") MagicNumber = 101110;
   if (Symbol() == "EURUSDm" || Symbol() == "EURUSD") MagicNumber = 101111;
   if (Symbol() == "GBPCHFm" || Symbol() == "GBPCHF") MagicNumber = 101112;
   if (Symbol() == "GBPJPYm" || Symbol() == "GBPJPY") MagicNumber = 101113;
   if (Symbol() == "GBPUSDm" || Symbol() == "GBPUSD") MagicNumber = 101114;
   if (Symbol() == "NZDJPYm" || Symbol() == "NZDJPY") MagicNumber = 101115;
   if (Symbol() == "NZDUSDm" || Symbol() == "NZDUSD") MagicNumber = 101116;
   if (Symbol() == "USDCHFm" || Symbol() == "USDCHF") MagicNumber = 101117;
   if (Symbol() == "USDJPYm" || Symbol() == "USDJPY") MagicNumber = 101118;
   if (Symbol() == "USDCADm" || Symbol() == "USDCAD") MagicNumber = 101119;
   
   if (MagicNumber == 0) MagicNumber = 701999;
   
   if(Digits==3 || Digits==5) BrokerDecimal = 10;


   return(0);
}

int deinit()
{
   return(0);
}

int start()
{

   //Login();

   STOP = "";
   TradingHoliday();
   
   int y;
   int cb=0; // Count buy
   int cs=0; // Count sell
   int cbl=0; // Count buy limit
   int csl=0; // Count sell limit
   int cbs=0; // Count buy limit
   int css=0; // Count sell limit
   double tbl=0; //Count lot size
   double tsl=0; //Count lot size
   double tl=0; //total lots out
   double to=0; //total buy and sell order out
   double buysl=0; //stop losses are set to zero if POSL off
   double sellsl=0; //stop losses are set to zero if POSL off
   double POSL=0; //Initialize POSL
   double tp2;
   double pr=0; // profit;   
   double         counter;
   int            moves;
   double         ProfitSL;   
   double ProfitPot=0;
   double CurrentTP=0;
   double pipvalue;
   
   pipvalue=MarketInfo(Symbol(),MODE_TICKVALUE);
  
//+------------------------------------------------------------------+
//| Calculate Total Profits and Total Orders                         |
//+------------------------------------------------------------------+ 
for (y = 0; y < OrdersTotal(); y++)
{
   OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
   if ((OrderMagicNumber()==MagicNumber) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUY)) {
      cb++;
      pr=pr+OrderProfit() + OrderSwap() + OrderCommission();
      tbl=tbl+OrderLots();
      ProfitPot=ProfitPot + OrderSwap() + OrderCommission() + OrderLots()*pipvalue*(((OrderTakeProfit() - OrderOpenPrice())/Point));
      CurrentTP=OrderTakeProfit();
   }
   if ((OrderMagicNumber()==MagicNumber) && (OrderSymbol()==Symbol()) && (OrderType()==OP_SELL)) {
      cs++;
      pr=pr+OrderProfit() + OrderSwap() + OrderCommission();
      tsl=tsl+OrderLots();
      ProfitPot=ProfitPot + OrderSwap() + OrderCommission() + OrderLots()*pipvalue*(((OrderOpenPrice() - OrderTakeProfit())/Point));
      CurrentTP=OrderTakeProfit();
   }
   if ((OrderMagicNumber()==MagicNumber) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUYLIMIT)) cbl++;
   if ((OrderMagicNumber()==MagicNumber) && (OrderSymbol()==Symbol()) && (OrderType()==OP_SELLLIMIT)) csl++;
   if ((OrderMagicNumber()==MagicNumber) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUYSTOP)) cbs++;
   if ((OrderMagicNumber()==MagicNumber) && (OrderSymbol()==Symbol()) && (OrderType()==OP_SELLSTOP)) css++;
   tl=tbl+tsl;
   to=cb+cs;
}

ProfitPot = NormalizeDouble(ProfitPot,2);
pr        = NormalizeDouble(pr,2);  
      
      
//+------------------------------------------------------------------+
//| Adjust TP if ProfitPot is < 0                                    |
//+------------------------------------------------------------------+
                
if (bufferPIP > 0.0 && ProfitPot < 0.0) {
   double newTP;
   if (cb > 0 && CurrentTP > 0.0) {
      newTP = CurrentTP + (bufferPIP*Point);
         for (y = 0; y < OrdersTotal(); y++){ // Sync TPs
            OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
            if ((OrderMagicNumber() != MagicNumber) || (OrderType()!=OP_BUY) || (MathAbs(OrderTakeProfit()-newTP)<Point) || (OrderSymbol()!=Symbol())) { continue; }
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),newTP,0,Blue);
         } 
      return;
   }
   if (cs > 0 && CurrentTP > 0.0) {
      newTP = CurrentTP - (bufferPIP*Point);
      for (y = 0; y < OrdersTotal(); y++){ // Sync TPs
         OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
         if ((OrderMagicNumber() != MagicNumber) || (OrderType()!=OP_SELL) || (MathAbs(OrderTakeProfit()-newTP)<Point) || (OrderSymbol()!=Symbol())) { continue; }
         OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),newTP,0,Blue);
      } 
      return;                        
   }
}      
      
   
//+------------------------------------------------------------------+
//| Maximize Profit with Moving TP and setting Trailing Profit Stop  |
//+------------------------------------------------------------------+

if(MaximizeProfit) { 
   if(ProfitSL > 0 && pr <= ProfitSL)
   ExitAllTrades(Green,"Profit Trailing Stop Reached");
   if(to == 0){ 
      counter  = 0;
      moves    = 0;
      ProfitSL = 0;}
   if((pr && ProfitPot) > 0){
      if(pr/ProfitPot >= ProfitSet/100) ProfitSL = pr - (pr * (1-(ProfitSet/100)));}
      if(ProfitSL > 0 && ProfitSL > counter && MoveTP > 0 && TotalMoves > moves) {
         for (y = 0; y < OrdersTotal(); y++) {
            OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
            if ((OrderMagicNumber()==MagicNumber) && (OrderSymbol()==Symbol()) && (OrderType()==OP_BUY)) {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),(CurrentTP+(MoveTP*Point)),0,Blue); 
            }
            if ((OrderMagicNumber()==MagicNumber) && (OrderSymbol()==Symbol()) && (OrderType()==OP_SELL)) {
            OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss(),(CurrentTP-(MoveTP*Point)),0,Red); 
            
            } 
         }
         moves++;   
         counter = ProfitSL;
       }
    } 
      
      
//+------------------------------------------------------------------+
//| Fibonacci                                                        |
//+------------------------------------------------------------------+     
   
   double LowestData, HighestData;   


   LowestData = Low[iLowest(Symbol(),PERIOD_H4,0, LowBar,0)];
   HighestData = High[iHighest(Symbol(),PERIOD_H4,0, HighBar,0)];

   
   
   double Spread = MathAbs(Ask-Bid);

   if(LowestData > Bid)
   {
      LowestData = Bid;
   }
   
   if(HighestData < Ask)
   {
      HighestData = Ask;
   }      

   
   double DiffBuy  = HighestData - LowestData;
   double DiffSell = LowestData - HighestData;
   

   
   //Fibos
   // B = Buy Signal, S = Sell Signal
   
   double B_236 = HighestData + Spread + (DiffBuy * (23.6/100));
   double B_382 = HighestData + Spread + (DiffBuy * (38.2/100));
   double B_500 = HighestData + Spread + (DiffBuy * (50.0/100));
   double B_618 = HighestData + Spread + (DiffBuy * (61.8/100));
   double B_1000 = HighestData + Spread + (DiffBuy * (1000/100));   
   double B_1618 = HighestData + Spread + (DiffBuy * (161.8/100));
   double B_2618 = HighestData + Spread + (DiffBuy * (261.8/100));      

   double S_236 = LowestData - Spread + (DiffSell * (23.6/100));
   double S_382 = LowestData - Spread + (DiffSell * (38.2/100));
   double S_500 = LowestData - Spread + (DiffSell * (50.0/100));
   double S_618 = LowestData - Spread + (DiffSell * (61.8/100));
   double S_1000 = LowestData - Spread + (DiffSell * (100/100));   
   double S_1618 = LowestData - Spread + (DiffSell * (161.8/100));
   double S_2618 = LowestData - Spread + (DiffSell * (261.8/100));      

   /*
   Print("L: ",LowestData);
   Print("H: ",HighestData);
   Print("CB: ",B_236);
   Print("CS: ",S_236);
   */      
   



//+------------------------------------------------------------------+
//| Money Management                                                 |
//+------------------------------------------------------------------+   

   //double pcnt =( (AccountEquity()-AccountBalance()) / AccountBalance())*100;
   double PortionBalance = NormalizeDouble(AccountBalance()/Portion,2);
   double PortionEquity  = NormalizeDouble(AccountEquity(),2);
   if ( PortionBalance - PortionEquity >= (PortionBalance * FloatPercent/100) )
   {  
      ExitAllTrades(Red,"Equity Stop Loss Reached");
   }

   // StopLoss calculator
   buysl  = S_1000;
   sellsl = B_1000;   
   
   //buysl  = iSAR(Symbol(),0,SAR_Step,SAR_Max,1);
   //sellsl = iSAR(Symbol(),0,SAR_Step,SAR_Max,1);
   
   if(TrailingStopManager)
   {
      trailingStopManager(TrailingStop, TrailOnlyProfit);
   }
   

   

//+------------------------------------------------------------------+
//| Set Lot Size                                                     |
//+------------------------------------------------------------------+   
   
   double Contracts, Factor, Lotsize, lot, lot2;
   double lp,ll,ltp,lticket, sumlot,mp,lclt;
   double lopt = 0.0;
   
   double Divider = 100;
   
   
   if (AccountBalance()>1000)
   {
      Divider = 150;
   }
   if (AccountBalance()>3000)
   {
      Divider = 200;
   }
   if (AccountBalance()>5000)
   {
      Divider = 300;
   }
   if (AccountBalance()>10000)
   {
      Divider = 400;
   }
   if (AccountBalance()>20000)
   {
      Divider = 800;
   }
   
   Contracts = (AccountBalance()/Divider)/Portion;
   Factor    = Multiplier+
               MathPow(Multiplier,2)+
               MathPow(Multiplier,3)+
               MathPow(Multiplier,4)+
               MathPow(Multiplier,5)+
               MathPow(Multiplier,6);

   Lotsize=LAF*Accounttype*(Contracts/(1.0 + Factor));
      
   //Determine Lot size boundries from minimum to maximum
   lot=NormalizeDouble(Lotsize,2);
  
   if(Lotsize<0.01) lot=0.01;
   if(Lotsize>100/MathPow(Multiplier,6) && Accounttype == 1) lot=NormalizeDouble(100/MathPow(Multiplier,6),2);
   if(Lotsize>50/MathPow(Multiplier,6)  && Accounttype == 10) lot=NormalizeDouble(50/MathPow(Multiplier,6),2);   
   

   for (y = 0; y < OrdersTotal(); y++){
       OrderSelect (y, SELECT_BY_POS, MODE_TRADES);
       lp=OrderOpenPrice();
       ll=OrderLots();
       ltp=OrderTakeProfit();
       lopt=OrderOpenTime();
       lticket=OrderTicket();
       sumlot=sumlot+ll;
       mp=mp+ll*lp;
   }
   int cnt;
   int TheHistoryTotal=HistoryTotal();
   int difference;
   for(cnt=0;cnt<TheHistoryTotal;cnt++) {
      if(OrderSelect(cnt,SELECT_BY_POS,MODE_HISTORY)==true)
      {
           if ( (OrderSymbol()==Symbol()) && (OrderMagicNumber()==MagicNumber) ) {
               lclt=OrderCloseTime();
           }
      }  
   }
   //Print(lopt);
   //Print(lclt);
  
   if (to > 1)
   {
      if (ll <= 0.01) lot=NormalizeDouble(ll*2,2); else lot=NormalizeDouble(ll*Multiplier,2); 
   }  



//+------------------------------------------------------------------+
//| Ichimoku                                                         |
//+------------------------------------------------------------------+      

   int TenkanSen_Fast = TenkanSen/IchiFastDivider; 
   int KijunSen_Fast = KijunSen/IchiFastDivider;
   int SenkoSpan_Fast = SenkoSpan/IchiFastDivider;


   int TenkanSen_Slow = TenkanSen*IchiSlowMultiplier;
   int KijunSen_Slow = KijunSen*IchiSlowMultiplier;
   int SenkoSpan_Slow = SenkoSpan*IchiSlowMultiplier;

   
   double Ichi_Tenkan = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_TENKANSEN, 1);   
   double Ichi_Kijun = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_KIJUNSEN, 1);
   double Ichi_A = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_SENKOUSPANA, 1);
   double Ichi_B = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_SENKOUSPANB, 1);
   double Ichi_Chikou = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_CHINKOUSPAN, KijunSen+1);


   double Ichi_Tenkan_Fast = iIchimoku(NULL, IchiTF_Fast, TenkanSen_Fast, KijunSen_Fast, SenkoSpan_Fast, MODE_TENKANSEN, 1);   
   double Ichi_Kijun_Fast = iIchimoku(NULL, IchiTF_Fast, TenkanSen_Fast, KijunSen_Fast, SenkoSpan_Fast, MODE_KIJUNSEN, 1);
   double Ichi_A_Fast = iIchimoku(NULL, IchiTF_Fast, TenkanSen_Fast, KijunSen_Fast, SenkoSpan_Fast, MODE_SENKOUSPANA, 1);
   double Ichi_B_Fast = iIchimoku(NULL, IchiTF_Fast, TenkanSen_Fast, KijunSen_Fast, SenkoSpan_Fast, MODE_SENKOUSPANB, 1);
   double Ichi_Chikou_Fast = iIchimoku(NULL, IchiTF_Fast, TenkanSen_Fast, KijunSen_Fast, SenkoSpan_Fast, MODE_CHINKOUSPAN, KijunSen_Fast+1);


   double Ichi_Tenkan_Prev = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_TENKANSEN, 2);
   double Ichi_Kijun_Prev = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_KIJUNSEN, 2);
   double Ichi_Tenkan_Now = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_TENKANSEN, 0);
   //double Ichi_A_Prev = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_SENKOUSPANA, 2;
   //double Ichi_B_Prev = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_SENKOUSPANB, 2);


//+------------------------------------------------------------------+
//| Ichimoku Future Calculation                                      |
//+------------------------------------------------------------------+     
   double Ichi_A_Future = 0;
   double Ichi_B_Future = 0;
   double Ichi_A_Future_Fast = 0;
   double Ichi_B_Future_Fast = 0;
   double Ichi_A_Future_Slow = 0;
   double Ichi_B_Future_Slow = 0;


   

   for(int IchiTest=0; IchiTest>=-50; IchiTest--)
   {    
   
      if(iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_SENKOUSPANA, IchiTest) == 0 && Ichi_A_Future == 0)
      {
         Ichi_A_Future = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_SENKOUSPANA, IchiTest+1);
         Ichi_B_Future = iIchimoku(NULL, 0, TenkanSen, KijunSen, SenkoSpan, MODE_SENKOUSPANB, IchiTest+1);
      }
   
      if(iIchimoku(NULL, IchiTF_Fast, TenkanSen_Fast, KijunSen_Fast, SenkoSpan_Fast, MODE_SENKOUSPANA, IchiTest) == 0 && Ichi_A_Future_Fast == 0)
      {
         Ichi_A_Future_Fast = iIchimoku(NULL, IchiTF_Fast, TenkanSen_Fast, KijunSen_Fast, SenkoSpan_Fast, MODE_SENKOUSPANA, IchiTest+1);
         Ichi_B_Future_Fast = iIchimoku(NULL, IchiTF_Fast, TenkanSen_Fast, KijunSen_Fast, SenkoSpan_Fast, MODE_SENKOUSPANB, IchiTest+1);   
      }

      if(iIchimoku(NULL, IchiTF_Slow, TenkanSen_Slow, KijunSen_Slow, SenkoSpan_Slow, MODE_SENKOUSPANA, IchiTest) == 0 && Ichi_A_Future_Slow == 0)
      {
         Ichi_A_Future_Slow = iIchimoku(NULL, IchiTF_Slow, TenkanSen_Slow, KijunSen_Slow, SenkoSpan_Slow, MODE_SENKOUSPANA, IchiTest+1);
         Ichi_B_Future_Slow = iIchimoku(NULL, IchiTF_Slow, TenkanSen_Slow, KijunSen_Slow, SenkoSpan_Slow, MODE_SENKOUSPANB, IchiTest+1);
      }   
   }
   /*
   Print("Normal: ",Ichi_A_Future);
   Print("Fast: ",Ichi_A_Future_Fast);
   Print("Slow: ",Ichi_A_Future_Slow);
   */
   




//+------------------------------------------------------------------+
//| Decision                                                         |
//+------------------------------------------------------------------+

   string iFinal = "Stay";
   
   int Test;
   for (y = 0; y < KijunSen; y++){
      if(Low[y]/High[y] < 0.99)
      {
         Test++;
      }
   }

   
   
//+------------------------------------------------------------------+
//| Scme Hack                                                        |
//+------------------------------------------------------------------+   
   bool Force = false;
   double l_icustom_8 = 0;
   double l_icustom_16 = 0;
   double vol = 0;
   
   if(Period()==PERIOD_H1)
   {
      Force = iCCI(Symbol(),0,7,PRICE_HIGH,1) > -75 && iCCI(Symbol(),0,7,PRICE_HIGH,1) < 75 
                   && iForce(Symbol(),0,15,MODE_SMA,PRICE_CLOSE,1) > -0.5 
                   && iForce(Symbol(),0,15,MODE_SMA,PRICE_CLOSE,1) < 0.9 
                   && Test == 0;
      l_icustom_16 = iCustom(NULL, 0, "VROC", VROC, 0, 1);
      vol = 20.0;  
      //Print("H1");                    
      buysl  = Ichi_B-(150*Point);
      sellsl = Ichi_B+(150*Point);

                   
   }  
 
   int Ichi_Tenkan_Int = Ichi_A * 1000;
   int Ichi_Kijun_Int  = Ichi_B  * 1000;   
   
   
   if (   Ichi_Tenkan > Ichi_Kijun
       && Ichi_Tenkan > Ichi_Tenkan_Prev
       && Ichi_Tenkan_Fast > Ichi_Kijun_Fast
       && Ichi_A < Ichi_Tenkan
       && Ichi_A < Ichi_Kijun
       && Ichi_B < Ichi_Tenkan
       && Ichi_B < Ichi_Kijun  
       && Ichi_A > Ichi_B     
       && Force == true
       && Ichi_Kijun_Int != Ichi_Tenkan_Int
       && l_icustom_16 < vol
       && Open[1] > Ichi_A
      )
      //Print(l_icustom_16);
   {
      iFinal = "Buy";
      //Print("Ichi_A: ",Ichi_A);
      //Print("Ichi_B: ",Ichi_B);
      //Print("Ichi_Tenkan: ",Ichi_Tenkan);
      //Print("Ichi_Kijun: ",Ichi_Kijun);      
   }

   if (   Ichi_Tenkan < Ichi_Kijun
       && Ichi_Tenkan < Ichi_Tenkan_Prev
       && Ichi_Tenkan_Fast < Ichi_Kijun_Fast
       && Ichi_A > Ichi_Tenkan
       && Ichi_A > Ichi_Kijun
       && Ichi_B > Ichi_Tenkan
       && Ichi_B > Ichi_Kijun 
       && Ichi_A < Ichi_B  
       && Force == true
       && Ichi_Kijun_Int != Ichi_Tenkan_Int
       && l_icustom_16 < vol   
       && Open[1] < Ichi_A 
      )
   {
      iFinal = "Sell";
   }

   if(STOP == "Stop")
   {
      iFinal = "Stay";   
   } 

//+------------------------------------------------------------------+
//| Fibonacci TakeProfit                                             |
//+------------------------------------------------------------------+   
   double TakeProfitB,TakeProfitS;
   
   TakeProfitB = B_618;//B_236;
   TakeProfitS = S_618;//S_236;
   
   if(TakeProfitB <= Bid)
   {
      TakeProfitB = B_382;
   }   

   if(TakeProfitB <= Bid)
   {
      TakeProfitB = B_500;
   }
      
   
   if(TakeProfitB <= Bid)
   {
      TakeProfitB = B_618;
   }
   
   if(TakeProfitB <= Bid)
   {
      TakeProfitB = B_1618;
   }   
   
   if(TakeProfitB <= Bid)
   {
      TakeProfitB = B_2618;
   }   


   if(TakeProfitS >= Ask)
   {
      TakeProfitS = S_382;
   }   
   
   if(TakeProfitS >= Ask)
   {
      TakeProfitS = S_500;
   }    
   
   if(TakeProfitS >= Ask)
   {
      TakeProfitS = S_618;
   }
   
   if(TakeProfitS >= Ask)
   {
      TakeProfitS = S_1618;
   }   
   
   if(TakeProfitS >= Ask)
   {
      TakeProfitS = S_2618;
   }     
   

   TakeProfitB = Bid + (135*Point);
   TakeProfitS = Ask - (135*Point);

//+------------------------------------------------------------------+
//| IchiMoku StopLoss                                                |
//+------------------------------------------------------------------+   
   //buysl  = Ichi_B;
   //sellsl = Ichi_B;
   
   
   if (iFinal == "Buy" && (TimeCurrent()-TimeGrid>lopt) && (TimeCurrent()-TimeGridClose>lclt) && (TimeHour(TimeCurrent()) < 5 || TimeHour(TimeCurrent()) > 8))
   {
   //Print("SL: ",buysl);
   //Print("Fibo: ",TakeProfitB);
   //Print("Ask: ",Ask);
   //Print(lclt);
      if(HedgingAllowed == true)
      {
         OrderSend(Symbol(),OP_BUY,lot,Ask,0,buysl,TakeProfitB,TradeComment,MagicNumber,0,Blue);
      }else{
         if(cbs > 0 || cbs == 0 && css == 0 )
         {
            OrderSend(Symbol(),OP_BUY,lot,Ask,0,buysl,TakeProfitB,TradeComment,MagicNumber,0,Blue);
         }
      }
   }

   if (iFinal == "Sell" && (TimeCurrent()-TimeGrid>lopt) && (TimeCurrent()-TimeGridClose>lclt) && (TimeHour(TimeCurrent()) < 5 || TimeHour(TimeCurrent()) > 8))
   {
   //Print("SL: ",sellsl);
   //Print("Fibo: ",TakeProfitS);
   //Print("Bid: ",Bid);
   //Print(lclt);
      if(HedgingAllowed == true)
      {   
         OrderSend(Symbol(),OP_SELL,lot,Bid,0,sellsl,TakeProfitS,TradeComment,MagicNumber,0,Red);
      }else{
         if(css > 0 || css == 0 && cbs == 0)
         {
            OrderSend(Symbol(),OP_SELL,lot,Bid,0,sellsl,TakeProfitS,TradeComment,MagicNumber,0,Red);
         }      
      }
   }


   return(0);
}






//+------------------------------------------------------------------+
//| Exit Trade Function                                              |
//+------------------------------------------------------------------+ 

  void ExitAllTrades(color Color, string reason){
    double slip = NormalizeDouble((slippage * BrokerDecimal),0);
    bool success;
    for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber){
         OrderDelete(OrderTicket(),Color);
         success=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), slip, Color);
         if(success==true){
            Print("Closed all positions because ",reason);} } } }   
            

  void ExitAllTradesDirection(string direction){
    double slip = NormalizeDouble((slippage * BrokerDecimal),0);
    color Color = Red;
    bool success;
    for (int cnt = OrdersTotal() - 1; cnt >= 0; cnt --){
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if (OrderSymbol() == Symbol() && OrderMagicNumber() == MagicNumber){
         if((OrderType()==OP_BUY || OrderType()==OP_BUYSTOP) && direction == "Buy")         
         {
            OrderDelete(OrderTicket(),Color);
            success=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), slip, Color);
         }
         if((OrderType()==OP_SELL || OrderType()==OP_SELLSTOP) && direction == "Sell")         
         {
            OrderDelete(OrderTicket(),Color);
            success=OrderClose(OrderTicket(), OrderLots(), OrderClosePrice(), slip, Color);
         }
         if(success==true){
            Print("Closed all positions because "); return(0);} } } }   


//+------------------------------------------------------------------+
//| Trailing stop Function                                           |
//+------------------------------------------------------------------+ 

void trailingStopManager(int TrailingStop, int OnlyTrailProfits) {
   double l_point_8;
   double l_bid_16;
   double l_ask_24;
   double StopLevel;
   for (int l_pos_32 = 0; l_pos_32 < OrdersTotal(); l_pos_32++) {
      OrderSelect(l_pos_32, SELECT_BY_POS, MODE_TRADES);
      if (TrailingStop > 0) {
         l_bid_16 = MarketInfo(OrderSymbol(), MODE_BID);
         l_ask_24 = MarketInfo(OrderSymbol(), MODE_ASK);
         l_point_8 = MarketInfo(OrderSymbol(), MODE_POINT);
         StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
         if(TrailingStop < StopLevel)
         {
            TrailingStop = StopLevel;
         }
         
         if ((OrderMagicNumber()==MagicNumber) && OrderType() == OP_BUY) {
            if (l_bid_16 - OrderOpenPrice() > l_point_8 * TrailingStop || OnlyTrailProfits == 0)
            {
               if (OrderStopLoss() < l_bid_16 - l_point_8 * TrailingStop) 
               {
                  OrderModify(OrderTicket(), OrderOpenPrice(), l_bid_16 - l_point_8 * TrailingStop, OrderTakeProfit(), 0, Green);
               }
            }
               
               
         } else {
            if ((OrderMagicNumber()==MagicNumber) && OrderType() == OP_SELL) {
               if (OrderOpenPrice() - l_ask_24 > l_point_8 * TrailingStop || OnlyTrailProfits == 0)
               {
                  if (OrderStopLoss() > l_ask_24 + l_point_8 * TrailingStop || OrderStopLoss() == 0.0) 
                  {
                     OrderModify(OrderTicket(), OrderOpenPrice(), l_ask_24 + l_point_8 * TrailingStop, OrderTakeProfit(), 0, Red);
                  }
               }
            }
         }
      }
   }
}

int TradingHoliday()
{
if(
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.01.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.01.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.01.01"))) || (TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.01.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.01.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.01.01"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.01.21")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.01.21")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.01.21"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.02.18")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.02.18")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.02.18"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.03.21")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.03.21")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.03.21"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.03.24")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.03.24")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.03.24"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.04.25")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.04.25")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.04.25"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.05.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.05.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.05.01"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.05.08")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.05.08")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.05.08"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.05.12")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.05.12")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.05.12"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.05.26")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.05.26")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.05.26"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.07.04")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.07.04")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.07.04"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.07.14")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.07.14")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.07.14"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.08.15")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.08.15")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.08.15"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.09.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.09.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.09.01"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.10.03")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.10.03")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.10.03"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.10.13")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.10.13")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.10.13"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.11.11")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.11.11")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.11.11"))) || (TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.11.11")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.11.11")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.11.11"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.11.27")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.11.27")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.11.27"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.12.08")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.12.08")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.12.08"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.12.24")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.12.24")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.12.24"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.12.25")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.12.25")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.12.25"))) || (TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.12.25")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.12.25")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.12.25"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.12.26")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.12.26")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.12.26"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2008.12.31")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2008.12.31")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2008.12.31"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.01.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.01.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.01.01"))) || (TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.01.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.01.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.01.01"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.01.06")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.01.06")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.01.06"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.01.19")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.01.19")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.01.19"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.02.16")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.02.16")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.02.16"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.04.10")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.04.10")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.04.10"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.04.13")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.04.13")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.04.13"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.05.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.05.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.05.01"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.05.08")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.05.08")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.05.08"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.05.21")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.05.21")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.05.21"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.05.25")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.05.25")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.05.25"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.06.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.06.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.06.01"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.07.03")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.07.03")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.07.03"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.07.14")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.07.14")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.07.14"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.09.07")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.09.07")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.09.07"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.10.12")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.10.12")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.10.12"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.11.11")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.11.11")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.11.11"))) || (TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.11.11")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.11.11")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.11.11"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.01.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.01.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.01.01"))) || (TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.01.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.01.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.01.01"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.01.06")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.01.06")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.01.06"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.01.18")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.01.18")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.01.18"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.02.15")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.02.15")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.02.15"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.04.02")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.04.02")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.04.02"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.04.05")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.04.05")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.04.05"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.05.13")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.05.13")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.05.13"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.05.24")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.05.24")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.05.24"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.05.31")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.05.31")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.05.31"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.07.05")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.07.05")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.07.05"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.07.14")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.07.14")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.07.14"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.09.06")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.09.06")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.09.06"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.10.11")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.10.11")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.10.11"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.11.01")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.11.01")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.11.01"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.11.11")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.11.11")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.11.11"))) || (TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.11.11")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.11.11")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.11.11"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.11.25")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.11.25")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.11.25"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.12.08")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.12.08")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.12.08"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.12.24")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.12.24")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.12.24"))) || (TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.12.24")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.12.24")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.12.24"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2010.12.31")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2010.12.31")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2010.12.31"))) || 
(TimeYear(TimeCurrent()) == TimeYear(StrToTime("2009.11.26")) && TimeMonth(TimeCurrent()) == TimeMonth(StrToTime("2009.11.26")) && TimeDay(TimeCurrent()) == TimeDay(StrToTime("2009.11.26")))
)
{
   STOP = "Stop";
   return;
}
}

int Login()
{

   int hwnd = WindowHandle(Symbol(), Period());
   int hwnd_parent = 0;      
   //if (TimeHour (TimeCurrent()) != TimeHour(TimeLocal()) ) {
   if (MathAbs(TimeLocal() - TimeCurrent()) > 600){

      Print(TimeHour(TimeLocal()));
      Print(TimeHour(TimeCurrent()));
   
      hwnd = GetDlgItem(hwnd_parent, 0xE81C); // ????? ????????? ???? ?????????
      hwnd = GetDlgItem(hwnd, 0x52);
      hwnd = GetDlgItem(hwnd, 0x8A70);
      hwnd = GetLastActivePopup(hwnd_parent); // found login form
      PostMessageA(hwnd, WM_KEYDOWN, VK_ENTER, 0); // "enter" to login
      Sleep(1000);
   }
}